// ===========================================================================
//	CActiveXIdleScheduler.h	1996 Microsoft Corporation. All rights reserved.
// ===========================================================================
//
//	schedules Active X idle tasks

#include "HEADERS.H"

typedef struct
{
	IControl	*Control;
	Uint32		ControlRefCon;
	Uint32		WaitUntil;
	Int32		Interval;
	Boolean8	AfterAllEvents;
}
SchedControlStruct;


class CActiveXScheduler
{
public:
	// *** Constructors & Destructors ***
	CActiveXScheduler(void);
	~CActiveXScheduler(void);

	// *** static scheduler accessor ***
	static CActiveXScheduler*	GetActiveXScheduler(Boolean8 MakeIt = false);

	// *** scheduling functions ***
	ErrorCode	Idle(Boolean8 NullEvent);
	ErrorCode	IdleControl(Boolean8 NullEvent, IControl* inControl);
	ErrorCode	ScheduleControl(Boolean8 AfterAllEvents, Int32 Interval, IControl* inControl, Uint32 ControlRefCon);
	ErrorCode	RemoveControlByRefCon(IControl* inControl, Uint32 ControlRefCon);
	ErrorCode	RemoveControl(IControl* inControl);

	Boolean8	HasNullEventItems(void);
	Boolean8	HasAllEventItems(void);

private:
	// *** private methods ***
	void		Sort(void);

	// *** static variables ***
	static CActiveXScheduler*	sActiveXScheduler;

	// *** member variables ***
	SchedControlStruct**		mScheduledControls;
	Boolean8					mNeedsSorting;
};
