//
//	Container.h
//
//  Copyright (C) Microsoft Corporation, 1996
//

#ifndef __CCONTAINER_H__
#define	__CCONTAINER_H__

#include <LArray.h>
#include "Headers.h"

class CContainerManager;

class CContainer:
	public CBaseCOM,
    public IContainer
{
public:
	// Constructor/Destructor
	CContainer(void);
	CContainer(CContainerManager* inOwner, PlatformPort* inHostPort);
	~CContainer(void);

	//  *** IUnknown methods ***
	STDMETHOD(QueryInterface)(REFIID inRefID, void** outObj);
	STDMETHOD_(Uint32, AddRef)(void) { return CBaseCOM::AddRef(); }
	STDMETHOD_(Uint32, Release)(void) { return CBaseCOM::Release(); }

   // **** IContainer methods ***
   STDMETHOD (EnumControls) (THIS_ SearchSpec* inSpec, Uint32 inSearchDepth, IEnumUnknown** outEnumerator) ;
   
    // *** ContainerClient methods ***
    PlatformPort*  GetPort(void) { return mHostPort; }
    
   // **** Collection methods ***
	void AddSite (CXSite* inSite);
	void RemoveSite (CXSite* inSite);
	Uint32 GetCount(void);
	void FetchSite (Int16 inIndex, CXSite** outSite);
	

protected:
	PlatformPort*		mHostPort;
	CContainerManager*	mOwner;		// The container manager that owns us
	LArray				*mSiteArrayP;
	CCodeDownload		*mCodeDownloadP;


private:
	void				CommonInit(void);
};
#endif