//
//  BASESTRM.H
//
//  Copyright (C) Microsoft Corporation, 1996
//
//  Declares classes that wrap different functionality that require the use of
//  Netscape streams.
//

class CNetscapeStreamNotify
{
public:
    //  After calling NPN_GetURL, we don't have a NPStream structure to attach
    //  our notification object to, so we must wait until NPP_NewStream and scan
    //  the list of unattached objects.  We detect a match by comparing each
    //  notification object's URL against the URL provided to the NPP_NewStream
    //  callback.
    CNetscapeStreamNotify *m_pNextUnattached;
    LPOLESTR m_pszURL;

    inline CNetscapeStreamNotify();
    virtual ~CNetscapeStreamNotify();
    virtual NPError OnNewStream(NPMIMEType type, NPStream *stream, NPBool
        seekable, uint16 *stype);
    virtual int32 OnWriteReady(NPStream *stream);
    virtual int32 OnWrite(NPStream *stream, int32 offset, int32 len, void
        *buffer);
    virtual NPError OnDestroyStream(NPStream *stream, NPError reason) = 0;
    virtual void OnStreamAsFile(NPStream *stream, const char* fname);

protected:
	STGMEDIUM	mStorageMedium;
};

inline
CNetscapeStreamNotify::CNetscapeStreamNotify()
{
    m_pNextUnattached = NULL;
    m_pszURL = NULL;
}
