//----------------------------------------------
#if __cplusplus
extern "C" {
#endif
//----------------------------------------------

//----------------------------------------------
// Functions
//----------------------------------------------

Boolean	IsBinHexFile(FSSpec *pSourceFile, FSSpec *rDestFile);
Boolean	UnpackBinHexFile(FSSpec *pSourceFile, FSSpec *pDestFile, FSSpec *rDestFile);

//----------------------------------------------
// Low-level functions
//----------------------------------------------

#ifndef NO_OPAQUEBINHEXCLIENTDATA
typedef struct tOpaqueBinHexClientData *tBinHexClientData;
#endif

typedef struct tBinHexParser tBinHexParser;

typedef struct {
	Str63	fName;
	OSType	fFileType;
	OSType	fFileCreator;
	UInt16	fFinderFlags;
	} tBinHexFileInfo;

typedef struct {
	Boolean	(*SetFileInfo)(tBinHexClientData *pClientData, tBinHexFileInfo *pFileInfo);
	Boolean	(*WriteDF)(tBinHexClientData *pClientData, void *pData, long pDataLength);
	Boolean	(*WriteRF)(tBinHexClientData *pClientData, void *pData, long pDataLength);
	} tBinHexParserCallbacks;

Boolean	BinHexParser_New(tBinHexClientData *pClientData, tBinHexParserCallbacks *pCallbacks, tBinHexParser **rParser);
void	BinHexParser_Dispose(tBinHexParser *pParser);
Boolean	BinHexParser_Flush(tBinHexParser *pParser);
void	BinHexParser_Kill(tBinHexParser *pParser);
Boolean	BinHexParser_WriteData(tBinHexParser *pParser, void *pData, long pDataLength);
Boolean	BinHexParser_IsBinHex(tBinHexParser *pParser);

//----------------------------------------------
#if __cplusplus
}
#endif
//----------------------------------------------
