// =================================================================================
//
//	IPlatformControl.h			1996-97 Microsoft Corporation All rights reserved.
//
//	ActiveX type definitions
//
// =================================================================================

#ifndef _H_PlatformControl
#define _H_PlatformControl
#pragma once

typedef enum
{
	ControlActiveNoHilite = 0,			//	kControlNoPart
	ControlDeactiveDimmed = 255,		//	kControlInactivePart
	PadControlHiliteType = 0xffffffff
}
ControlHiliteType;

typedef enum
{
	PushButtonType = 0,					//	pushButProc
	CheckBoxType = 1,					//	checkBoxProc
	RadioButtonType = 2,				//	radioButProc
	ScrollBarType = 16,					//	scrollBarProc
	PopupMenuType = 1008,				//	popupMenuProc
	PadControlType = 0xffffffff
}
ControlType;

/////////////////////////////////////////////////////////////////////////////
// IPlatformControl interface
// Outgoing interface for the standard control events

DECLARE_INTERFACE_(IPlatformControl, IUnknown)
{
	BEGIN_INTERFACE

	// *** IUnknown methods ***
	STDMETHOD (QueryInterface)(THIS_ REFIID inRefID, void** outObj) PURE;
	STDMETHOD_(ULONG,AddRef)(THIS)  PURE;
	STDMETHOD_(ULONG,Release)(THIS) PURE;

	// *** IPlatformControl methods ***
	STDMETHOD (GetType)(THIS_ IUnknown* inSource, ControlType* outCntrlType) PURE;
	STDMETHOD (SetType)(THIS_ IUnknown* inSource, ControlType inCntrlType) PURE;
	STDMETHOD (GetSize)(THIS_ IUnknown* inSource, Int32* outWidth, Int32* outHeight) PURE;
	STDMETHOD (SetSize)(THIS_ IUnknown* inSource, Int32 inWidth, Int32 inHeight) PURE;
	STDMETHOD (GetVisible)(THIS_ IUnknown* inSource, Boolean8* outIsVisible) PURE;
	STDMETHOD (SetVisible)(THIS_ IUnknown* inSource, Boolean8 inShowIt) PURE;
	STDMETHOD (GetHilite)(THIS_ IUnknown* inSource, ControlHiliteType* outHiliteType) PURE;
	STDMETHOD (SetHilite)(THIS_ IUnknown* inSource, ControlHiliteType inHiliteType) PURE;
	STDMETHOD (GetTitle)(THIS_ IUnknown* inSource, Int32 inBufferSize, Char8* outControlTitle) PURE;
	STDMETHOD (SetTitle)(THIS_ IUnknown* inSource, Char8* inControlTitle) PURE;
	STDMETHOD (GetMinValue)(THIS_ IUnknown* inSource, Int32* outMinValue) PURE;
	STDMETHOD (SetMinValue)(THIS_ IUnknown* inSource, Int32 inMinValue) PURE;
	STDMETHOD (GetMaxValue)(THIS_ IUnknown* inSource, Int32* outMaxValue) PURE;
	STDMETHOD (SetMaxValue)(THIS_ IUnknown* inSource, Int32 inMaxValue) PURE;
	STDMETHOD (GetValue)(THIS_ IUnknown* inSource, Int32* outValue) PURE;
	STDMETHOD (SetValue)(THIS_ IUnknown* inSource, Int32 inValue) PURE;
	STDMETHOD (SetPageDistance)(THIS_ IUnknown* inSource, Int32 inPageDistance) PURE;
};


/////////////////////////////////////////////////////////////////////////////
// IPlatformControlListener interface
// Outgoing interface for the standard control events

DECLARE_INTERFACE_(IPlatformControlListener, IUnknown)
{
	BEGIN_INTERFACE

	// *** IUnknown methods ***
	STDMETHOD (QueryInterface)(THIS_ REFIID inRefID, void** outObj) PURE;
	STDMETHOD_(ULONG,AddRef)(THIS)  PURE;
	STDMETHOD_(ULONG,Release)(THIS) PURE;

	// *** IPlatformControlListener methods ***
	STDMETHOD (OnControlValueChange)(THIS_ IUnknown* inSource, Int32 ControlValue) PURE;
 };


#endif