// =================================================================================
//
//	ISLInterfaces.h				1996 Microsoft Corporation All rights reserved.
//
//	ISL COM interface definitions
//
// =================================================================================

#ifndef _H_ISLInterfaces
#define _H_ISLInterfaces
#pragma once

/////////////////////////////////////////////////////////////////////////////
// IISLClient interface
// Client callbacks from ISL

DECLARE_INTERFACE_(IISLClient, IUnknown)
{
	BEGIN_INTERFACE

	// *** IUnknown methods ***
	STDMETHOD (QueryInterface)(THIS_ REFIID inRefID, void** outObj) PURE;
	STDMETHOD_(ULONG,AddRef)(THIS)  PURE;
	STDMETHOD_(ULONG,Release)(THIS) PURE;

	// *** IISLClient methods ***
	STDMETHOD (PushStatusMessage) (THIS_ void *pStatusClient, char* pMessage) PURE;
	STDMETHOD (PopStatusMessage) (THIS_ void *pStatusClient, char* pMessage) PURE;
	STDMETHOD (ShowReadProgress) (THIS_ void *pStatusClient, int32 pTotalBytes, int32 pToDateBytes, char* pError) PURE;
	STDMETHOD (ShowWriteProgress) (THIS_ void *pStatusClient, int32 pTotalBytes, int32 pToDateBytes, char* pError) PURE;
	STDMETHOD (ShowSecureServerInfo) (THIS_ void *pStatusClient, tSecureServerInfo *pSecureServerInfo) PURE;
	STDMETHOD (Yield) (THIS) PURE;
	STDMETHOD (BeginModalDialog) (THIS) PURE;
	STDMETHOD (EndModalDialog) (THIS) PURE;
	STDMETHOD (DisposeClientData) (THIS_ void *pStatusClient, tStream *pStream) PURE;
};

#endif
