/*****************************************************************************\
*                                                                             *
* wintypes.h -  Windows compatible types and definitions                      *
*                                                                             *
*               OLE Version 2.0                                               *
*                                                                             *
*               Copyright (c) 1992-1996, Microsoft Corp. All rights reserved. *
*                                                                             *
\*****************************************************************************/

#ifndef _WINTYPES_H_
#define _WINTYPES_H_

#ifndef NULL
#ifdef __cplusplus
#define NULL    0
#else
#define NULL    ((void *)0)
#endif
#endif

#ifndef FALSE
#define FALSE               0
#endif

#ifndef TRUE
#define TRUE                1
#endif

/*
 * BASETYPES is defined in ntdef.h if these types are already defined
 */

#ifndef BASETYPES
#define BASETYPES
typedef unsigned long ULONG;
typedef ULONG *PULONG;
typedef unsigned short USHORT;
typedef USHORT *PUSHORT;
typedef unsigned char UCHAR;
typedef UCHAR *PUCHAR;
typedef char *PSZ;
#endif  /* !BASETYPES */

/*
 * _WINDEF_ is defined in windef.h if these types are already defined
 */

#ifndef _WINDEF_

typedef long                LONG;
typedef unsigned long       DWORD;
typedef int                 BOOL;
typedef unsigned char       BYTE;
typedef unsigned short      WORD;
typedef BOOL                *LPBOOL;
typedef BYTE                *LPBYTE;
typedef int                 *LPINT;
typedef WORD                *LPWORD;
typedef long                *LPLONG;
typedef DWORD               *LPDWORD;
typedef void                *LPVOID;
typedef const void          *LPCVOID;

typedef int                 INT;
typedef unsigned int        UINT;
typedef unsigned int        *PUINT;

/* Types use for passing & returning polymorphic values */
typedef UINT WPARAM;
typedef LONG LPARAM;
typedef LONG LRESULT;

#ifdef STRICT
typedef void *HANDLE;
#define DECLARE_HANDLE(name) struct name##__ { int unused; }; typedef struct name##__ *name
#else
typedef LPVOID HANDLE;
#define DECLARE_HANDLE(name) typedef HANDLE name
#endif

#endif /* _WINDEF */

/* Opaque handle types when interoperating with WLM-based components */
DECLARE_HANDLE(HWND);
DECLARE_HANDLE(HMENU);
DECLARE_HANDLE(HOLEMENU);
DECLARE_HANDLE(HDC);
DECLARE_HANDLE(HRGN);
DECLARE_HANDLE(HACCEL);
DECLARE_HANDLE(HBITMAP);
DECLARE_HANDLE(HMETAFILEPICT);
DECLARE_HANDLE(HENHMETAFILE);
DECLARE_HANDLE(HGLOBAL);

typedef LPVOID              LPMSG;

#endif /* _WINTYPES_H_ */
