// =================================================================================
//
//	platform.h						1996 Microsoft Corporation All rights reserved.
//
//	Platform-specific type definitions
//
// =================================================================================

#ifndef _H_AXPlatform
#define _H_AXPlatform
#pragma once

#ifndef __QUICKDRAW__
#include <Quickdraw.h>
#endif	//	__QUICKDRAW__

#ifndef __PRINTING__
#include <Printing.h>
#endif	//	__PRINTING__

#ifndef __EVENTS__
#include <Events.h>
#endif	//	__EVENTS__

typedef		char			Int8;
typedef		short			Int16;
typedef		long			Int32;

typedef		unsigned char	Uint8;
typedef		unsigned short	Uint16;
typedef		unsigned long	Uint32;

typedef		char			Char8;
typedef		Uint16			Char16;

typedef		unsigned char	Uchar8;

typedef		Int8			Boolean8;
typedef		Int16			Boolean16;
typedef		Int32			Boolean32;


typedef enum
{
	BeginPortType = 0,			//	enum boundary value
	QDWindowPortType,
	QDOffscreenPortType,
	QDPrintPortType,
	EndPortType,				//	enum boundary value
	PadPortType = 0xffffffff	//	insure enum takes 32 bits
}
PortType;


typedef GrafPort	PlatformPort;
typedef EventRecord PlatformEvent;
typedef Point		PlatformPoint;

typedef struct
{
	RgnHandle	Region;			// Macintosh Region Handle
	Char8		Reserved[32]; 	// Reserved for later use
}
PlatformRegion;

typedef struct
{
	PortType	PortType;
	Uint32		DrawAspect;
	Uint32 		ContextID;
	Uint32 		ContainerRef;
	GrafPtr		Port;
	THPrint		PrintRec;
	Rect		Location;
	Char8		Reserved[44];	//	this space to be used later
}
DrawContext;


typedef long ErrorCode;

#endif
