#include "ocheaders.h"
#include "CBaseControl.h"
#include "CErrorControl.h"
#include "CGradientControl.h"
#include "CError.h"
#include "CGradientError.h"
#include "FnAssert.h"
#include "BDUtils.h"

#define MControl ((CGradientControl *)mControl)

///////////////////////////////////////////////////////////////////////////////
//
// CGradientError::CGradientError
//

CGradientError::CGradientError(ErrorCode error) : CError(error)
{
}

CGradientError::CGradientError(ErrorCode error, CErrorControl * control)
	: CError(error, control)
{
}

///////////////////////////////////////////////////////////////////////////////
//
// CGradientError::HandleError
//

void CGradientError::HandleError(void)
{
	switch (mErrorCode)
	{
		case CONTROL_GWORLD_ALLOCATION_ERROR:
		{
			ASSERT(0, "The Gradient control gworld could not be allocated!");
			break;
		}

		case GWORLD_ALLOCATION_ERROR:
		{
			ASSERT(0, "A gworld could not be allocated!");
			break;
		}
					
		default:
			break;
	}
}
