///////////////////////////////////////////////////////////////////////////////
//
//	CMenuControl.h
//
//

#ifndef __CMenuControl__
#define __CMenuControl__

#include "BDInterfaces.h"
#include "C3DTextView.h"
#include "CPopupMenuControl.h"

///////////////////////////////////////////////////////////////////////////////
//
// class declaration
//

class CMenuControl :
	public C3DTextView, 
	public CPopupMenuControl
{
public:
	
    // *** CMenuControl methods ***
    CMenuControl();
    ~CMenuControl();

    // *** IControl methods ***
    STDMETHOD(Draw) (DrawContext* Context);
	STDMETHOD (DoMouse)(THIS_ MouseEventType inMouseET, PlatformEvent* inEvent);

    //  *** IPersistPropertyBag methods ***
	STDMETHOD(Load)(IPropertyBag* PropBag, IErrorLog* ErrorLog);

	// **** IDoMenuEvents methods
    STDMETHOD (Popup)(THIS_ IUnknown* Source, PlatformEvent* Event);

protected:
	void GetMenuLocation(const DrawContext & context, Point * menuLocation);
	
protected:
	char *	mCaption;
};


#endif // __CMenuControl__
