#include "ocheaders.h"
#include "CBaseControl.h"
#include "CErrorControl.h"
#include "CPopupWindowControl.h"
#include "CError.h"
#include "CPopupWindowError.h"
//#include "FnAssert.h"

#define MControl ((CPopupWindowControl *)mControl)

///////////////////////////////////////////////////////////////////////////////
//
// CPopupWindowError::CPopupWindowError
//

CPopupWindowError::CPopupWindowError(ErrorCode error) : CError(error)
{
}

CPopupWindowError::CPopupWindowError ( ErrorCode error, CErrorControl * control )
	: CError(error, control)
{
}

///////////////////////////////////////////////////////////////////////////////
//
// CPopupWindowError::HandleError
//

void CPopupWindowError::HandleError ( void )
{
	switch ( mErrorCode )
	{
		case DATA_ALLOCATION_ERROR:
		case NO_CNXN_PT_CONTAINER_ERROR:
		case CANT_ADD_CNXN_PT_ERROR:
		case CANT_ADVISE_CNXN_ERROR:
		case EOF_AND_NO_IMAGE_ERROR:
		case DATA_REALLOCATION_ERROR:
		case IMAGE_READ_ERROR:
		{
			break;
		}
		case CANT_ENUM_OBJECTS_ERROR:
		{
			MControl->mCookie = -1;
			break;
		}
			
		default:
			break;
	}
}
