#ifndef __CTickerError_h__
#define __CTickerError_h__

#include "CError.h"

class CTick;

/////////////////////////////////////////////////////////////////////////////
//
// constants
//

#define CONTROL_GWORLD_ALLOCATION_ERROR		(BaseErrorCodeTicker + 0)
#define TICK_GWORLD_ALLOCATION_ERROR		(BaseErrorCodeTicker + 1)
#define FONTINFO_ALLOCATION_ERROR			(BaseErrorCodeTicker + 2)
#define NAME_TOKENIZE_ALLOCATION_ERROR		(BaseErrorCodeTicker + 3)
#define VALUE_TOKENIZE_ALLOCATION_ERROR		(BaseErrorCodeTicker + 4)
#define TICK_NAME_ALLOCATION_ERROR			(BaseErrorCodeTicker + 5)
#define TICK_VALUE_ALLOCATION_ERROR			(BaseErrorCodeTicker + 6)
#define DATA_ALLOCATION_ERROR				(BaseErrorCodeTicker + 7)
#define DATA_REALLOCATION_ERROR				(BaseErrorCodeTicker + 8)

/////////////////////////////////////////////////////////////////////////////
//
// CTickerError class definition
//

class CTickerError : public CError
{
public:
	CTickerError(ErrorCode error);
	CTickerError(ErrorCode error, CErrorControl * control);
	CTickerError(ErrorCode error, CTick * tick);
	virtual void Init(ErrorCode error, CErrorControl * control);
	virtual void HandleError(void);

protected:
	CTick * mTick;
};

#endif // __CTickerError_h__
